/*******************************************************************************
 * Copyright (c) 2009 the CHISEL group and contributors.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * 	Del Myers -- initial API and implementation
 *******************************************************************************/
package org.eclipse.zest.custom.sequence;

/**
 * Color registry keys for UML charts.
 * @author Del Myers
 */

public interface IZestUMLColors {
	
	/**
	 * Color for activations
	 */
	public static final String COLOR_ACTIVATION = "COLOR_ACTIVATION";
	
	/**
	 * Color for classes.
	 */
	public static final String COLOR_CLASS = "COLOR_CLASS";
	
	/**
	 * Color for packages.
	 */
	public static final String COLOR_PACKAGE = "COLOR_PACKAGE";
	
	/**
	 * Color for activation calls
	 */
	public static final String COLOR_CALL = "COLOR_CALL";
	
	/**
	 * Color for activation returns
	 */
	public static final String COLOR_RETURN = "COLOR_RETURN";
	
	/**
	 * Default color for expandable elements.
	 */
	public static final String COLOR_EXPANDABLE = "COLOR_EXPANDABLE";
	
}
